module Kodmin
  class Plugins
    # Basic definition of plugin.
    class Plugin
      attr_reader :name
      attr_accessor :id, :created_at, :protocols, :enabled, :tags

      def initialize(attributes = {})
        from_hash(attributes)
      end

      def from_hash(attributes)
        attributes.each_key do |key|
          setter = "#{key}=".to_sym
          send(setter, attributes[key]) if respond_to?(setter)
        end
      end

      def to_hash
        hash = {}
        hash[:name] = name unless name.nil?
        hash[:id] = id unless nil.nil?
        hash[:created_at] = created_at unless created_at.nil?
        hash[:protocols] = protocols unless protocols.nil?
        hash[:enabled] = enabled unless enabled.nil?
        hash[:tags] = tags unless tags.nil?
        hash
      end
    end
  end
end
